/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Myk Melez, myk@mozilla.org, original author
   - 
*/

// Watches the submission of a search and the loading of search results.
var QueryObserver = {
  onBeginLoad: function(aSink) {} , 
  onInterrupt: function(aSink) {} , 
  onResume: function(aSink) {} , 

  onEndLoad: function(aSink)
  {
    var rawDS = aSink.QueryInterface(Components.interfaces.nsIRDFDataSource);
    var uri = rawDS.URI;
    var ds = RDFDataSource.all[uri];
    var tree = document.getElementById('results-tree');
    
    // When a user stops a running search, Bugxula doesn't actually stop
    // the data sources from loading, since I don't know any way to do that.
    // That means this routine might be called for a data source connected
    // to a search that is no longer running.  To check for that, we look up
    // the URI of the result that just finished loading and don't do anything
    // if it isn't in the list of active result sets.
    var results = getActiveResults();
    if (results.indexOfResource(uri) == -1) return;
    
    // Populate the results pane with the query results.
    tree.database.AddDataSource(rawDS);
    //tree.setAttribute('ref', rawDS.URI);

    // Decrement the count of loads the progress meter is tracking,
    // and rebuild the tree/update the UI if this is the last load.
    if (decrementProgressMeter() == 0)
    {
      gActiveSearch.state = "loaded";
      
      // Rebuild the tree so the data shows up.
      tree.builder.rebuild();
      
      // Update the results summary.
      var name = "<unsaved>";
      if (typeof gActiveSearch.name != "undefined" && gActiveSearch.name) 
        name = gActiveSearch.name;
      document.getElementById('search-name').value = "Active Search: " + name;
      document.getElementById('row-count').value = "Bug Count: " + tree.view.rowCount;
      document.getElementById('load-date').value = "Last Run: " + ds.loadDate;

      // Enable/disable search buttons depending on whether or not the results
      // come from a saved search.
      updateSearchOptions();
    }
  } , 

  onError: function(aSink, aStatus, aErrorMsg)
  {
    var rawDS = aSink.QueryInterface(Components.interfaces.nsIRDFDataSource);
    alert('An error occurred while trying to load the search "' + rawDS.URI + '".');
  }
};
