/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Myk Melez, myk@mozilla.org, original author
   - 
*/

// The active search (the one whose results are currently being displayed
// in the results pane).
var gActiveSearch = {};


// The default script and options for searching Bugzilla installations.
var gSearchOptions = "buglist.cgi?format=rdf&columnlist=all";

// The number of loading search results being tracked by the progress meter.
var gProgressCount = 0;

// The Bugzilla installation that current searches should be carried out on.
var gActiveInstallation;// = gMyPrefs.getUnicharPref('installation1.url'); // Needs to be changed to a default stored in preferences

function setActiveInstallation(instUrl,icon) {
	gActiveInstallation = instUrl;
//	document.getElementById('searchbar-dropmarker').src = icon;
//  Need to update searchbar icon and checkmark in menu here
}

function isInt(sText) {
   var ValidChars = "0123456789";
   var Char;
   for (i = 0; i < sText.length; i++) { 
      Char = sText.charAt(i); 
      if (ValidChars.indexOf(Char) == -1) {
         return false;
      }
   }
   return true;
}

function loadDataSource(url, observer)
{
  var ds;
  if ( typeof RDFDataSource.all[url] != "undefined" ) 
    ds = RDFDataSource.all[url];
  else
  {
    ds = new RDFDataSource(url);
    ds.setNameSpace('rdf', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#');
    ds.setNameSpace('bz', 'http://www.bugzilla.org/rdf#');
  }
  ds.load(observer);
  return ds;
}


function incrementProgressMeter(amount)
{
  if (!amount) amount = 1;
  gProgressCount = gProgressCount + amount;
  
  var progressMeter = document.getElementById("statusbar-progressmeter");
  progressMeter.setAttribute("mode", "undetermined");
}

function decrementProgressMeter()
{
  --gProgressCount;
  if (gProgressCount <= 0)
  {
    resetProgressMeter();
  }
  return(gProgressCount);
}

function resetProgressMeter()
{
  gProgressCount = 0;
  var progressMeter = document.getElementById("statusbar-icon");
  progressMeter.setAttribute("mode", "normal");
}

var gPersistableColumnAttrs = ['hidden', 'width', 'sortActive', 'sortDirection', 'ordinal'];

function persistColumnSettings()
{
  // Serializes results column settings and saves them to the active search's
  // database entry.
  
  // Don't do anything if the active search isn't saved.
  if (typeof gActiveSearch.uri == "undefined") return;
  
  var settings = getColumnSettings();
    
  var existingSettings = gUserDS.getTarget(gActiveSearch.uri, 'bz:columns');
  if (existingSettings)
    gUserDS.changeLiteral(gActiveSearch.uri, 'bz:columns', existingSettings, settings.toSource());
    else
    gUserDS.assertLiteral(gActiveSearch.uri, 'bz:columns', settings.toSource());
}

function restoreColumnSettings()
{
  if (!gActiveSearch.uri) return;
  
  var settings = gUserDS.getTarget(gActiveSearch.uri, 'bz:columns');
  if (!settings) return;
  
  // Deserialize the column settings from a string representation
  // of a JavaScript object to the object itself.
  eval("settings = " + settings + ";");
  
  setColumnSettings(settings);
}

function getColumnSettings()
{
  var columns = document.getElementById('results-columns').getElementsByTagName('treecol');
  
  var settings = {};
  var column, columnID, attribute;
  for ( var i = 0 ; i < columns.length ; i++ )
  {
    column = columns.item(i);
    columnID = column.getAttribute('id');
    
    settings[columnID] = {};
    for ( var j = 0 ; j < gPersistableColumnAttrs.length ; j++ )
    {
      attribute = gPersistableColumnAttrs[j];
      settings[columnID][attribute] = column.getAttribute(attribute);
    }
  }
  
  return settings;
}

function setColumnSettings(settings)
{
  var column, columnSettings;
  for (var columnID in settings)
  {
    column = document.getElementById(columnID);
    if (!column) continue;
    
    columnSettings = settings[columnID];
    for (var attribute in columnSettings)
      column.setAttribute(attribute, columnSettings[attribute]);
  }
}

// Turn this on to get debug output.
const debugOutput = false;
function ddump(text)
{
  if (debugOutput)
    dump(text + "\n");
}
function ddumpCont(text)
{
  if (debugOutput)
    dump(text);
}
function ddumpObject(obj, name, maxDepth, curDepth)
{
  if (!debugOutput)
    return;
  if (curDepth == undefined)
    curDepth = 0;
  if (maxDepth != undefined && curDepth > maxDepth)
    return;

  var i = 0;
  for (prop in obj)
  {
    i++;
    if (typeof(obj[prop]) == "object")
    {
      if (obj[prop] && obj[prop].length != undefined)
        ddump(name + "." + prop + "=[probably array, length "
              + obj[prop].length + "]");
      else
        ddump(name + "." + prop + "=[" + typeof(obj[prop]) + "]");
      ddumpObject(obj[prop], name + "." + prop, maxDepth, curDepth+1);
    }
    else if (typeof(obj[prop]) == "function")
      ddump(name + "." + prop + "=[function]");
    else
      ddump(name + "." + prop + "=" + obj[prop]);
  }
  if (!i)
    ddump(name + " is empty");    
}
function dumpError(text)
{
  dump(text + "\n");
}
 



function loadURLInBrowser(url)
{
  // Get the most recently used browser window, creating one if necessary.
  var navigatorWindow = getNavigatorWindow(true);
  if ( navigatorWindow._content )
  {
    navigatorWindow.loadURI(url);
    navigatorWindow.focus();
  }
  else
  {
    // Escapes quotes in strings being 'eval'ed.  Useful when passing 
    // the URL to load to this function using window.setTimeout.
    function esc(str) { return str.replace(/(['"])/g, "\\$1"); }
    window.setTimeout("loadURLInBrowser('" + esc(url) + "');", 1000);
  }
}


function getNavigatorWindow()
{
  // Returns a reference to a browser window.  Adapted from getNavigatorWindow()
  // in mozilla/xpfe/components/search/resources/search-panel.js.
  
  var navigatorWindow;
  
  // Get the most recently used browser window.
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  windowManager = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
  navigatorWindow = windowManager.getMostRecentWindow("navigator:browser");
 
  // If no browser window is available, open a new one.
  if (!navigatorWindow) {
    var navigatorChromeURL = 
      nsPreferences.copyUnicharPref("browser.chromeURL", "chrome://navigator/content/navigator.xul");
    navigatorWindow = openDialog(navigatorChromeURL, "_blank", "chrome,all,dialog=no");
  }
  return navigatorWindow;
}